' Bulletin Dater Program for PCBoard Version 14.0
'  by Rod L. Renner, SALEMDUG BBS, 202-646-2887
'
' Using a template and instructions in a .CFG file, this program finds each
' bulletin referenced and substitutes in the Date stamp of the bulletin.
' The program can look for non-graphics only or for Graphics first and can
' substitute in special values for a missing bulletin or one with a zero date.
'
' Version 1.0(eta) - 9/2/88: Initial Release
' Version 1.1 - 9/22/88: Added Date formats D-F and Time formats G-I
'                        Sets Output file date & time to the most recent of
'                        the bulletin dates (or Input template).
' Version 1.2 -12/10/89: Changes the way the date & time stamp is given to
'                        the Output File; introduces '-' as an indicator
'                        not to include this bulletin in calculating the
'                        date-time stamp for the Output file
'                       
'
   DEFINT A-Z:DIM MO$(12)
   FOR I=1 TO 12:READ MO$(I):NEXT
   DATA January,February,March,April,May,June,July,August,September,October,November,December
   KEY OFF:PRINT "Bulletin Dater v1.2 for PCBoard v14.0 - Rod L Renner, SALEMDUG BBS"
   PRINT
   ON ERROR GOTO 150
' Get name of .CFG file; default = BLTDATER.CFG
   CL$=COMMAND$:IF CL$="" THEN CL$="BLTDATER.CFG"
   PRINT "Opening Configuration File: ";CL$
5  OPEN CL$ FOR INPUT AS #1
' Read Date marker,substitute values for missing bulletin and no date (mm=00).
   IF EOF(1) THEN 140 ELSE INPUT#1,MRK$,NOBLT$,NODATE$
   IF LEN(MRK$)=0 OR MRK$=" " THEN 135
' Get next bulletin set to work on
20 IF EOF(1) THEN 125 ELSE INPUT#1,G$,TMPLT$,BLTLST$,BLTOUT$
   IF INSTR("Gg",LEFT$(G$+"N",1)) THEN G$="G":X$="" ELSE G$="":X$="Non-"
   PRINT:PRINT "Template File: ";TMPLT$:TMPLT0$=TMPLT$+CHR$(0)
   PRINT "Bulletin List: ";BLTLST$;" (";X$;"Graphics)"
   PRINT "Output File:   ";BLTOUT$:BLTOUT0$=BLTOUT$+CHR$(0)
' Initialize date&time of output file
   YR0=0:MO=0:DAY0=0:HR0=0:MN0=0:SEC0=0
'
   OPEN TMPLT$ FOR INPUT AS #2
   OPEN BLTOUT$ FOR OUTPUT AS #3
   OPEN BLTLST$ FOR RANDOM ACCESS READ AS #4 LEN=30
   FIELD #4,30 AS BLT$
'
30 IF EOF(2) THEN 120 ELSE LINE INPUT#2,N$
'
   J=1
35 M=INSTR(J,N$,MRK$):IF M=0 THEN 110
' Found marker - check for next char='-'
  FLG=0:IF MID$(N$,M+LEN(MRK$),1)="-" THEN FLG=1
' Get number after it
   N=0:FOR I=M+LEN(MRK$)+FLG TO LEN(N$)
       K=ASC(MID$(N$,I,1)):IF K<ASC("0") OR K>ASC("9") THEN 40
       N=10*N+K-ASC("0"):NEXT I:K=ASC("a")
' Get Bulletin Name, then get Bulletin Date
40 YEAR=-1:IF N<1 THEN 44 ELSE GET#4,N
   IF EOF(4) THEN 44 ELSE B$=BLT$
41 IF RIGHT$(B$,1)=" " THEN B$=LEFT$(B$,LEN(B$)-1):GOTO 41
   B1$=B$+G$+CHR$(0):B2$=B$+CHR$(0)
   CALL GETFDT(B1$,YEAR,MONTH,DAY,HOUR,MINUTE,SECOND)
   IF YEAR<0 THEN CALL GETFDT(B2$,YEAR,MONTH,DAY,HOUR,MINUTE,SECOND)
' Keep track of most recent Bulletin Date unless FLG is set
   IF YEAR>=0 AND FLG=0 THEN GOSUB 130
' Select which format to output the Date
44 ON (INSTR("AaBbCcDdEeFfGgHhIi",CHR$(K))+3)\2 GOTO 50,45,51,53,54,55,58,60,61,62
' Format "A" - use MM-DD-YY
45 I=I+1
' Not found in list; use Default = MM-DD-YY
50 C$="-":GOTO 52
' Format "B" - use MM/DD/YY
51 I=I+1:C$="/"
52 L=8:IF YEAR<0 THEN 98
   IF MONTH<1 OR MONTH>12 THEN 99
   DT$=RIGHT$(STR$(MONTH),2)+C$+RIGHT$(STR$(DAY+100),2)+C$+RIGHT$(STR$(YEAR),2)
   GOTO 100
' Format "C" - use DD Mon YY
53 I=I+1
   L=9:IF YEAR<0 THEN 98
   IF MONTH<1 OR MONTH>12 THEN 99
   DT$=LEFT$(MO$(MONTH),3)
   DT$=RIGHT$(STR$(DAY+100),2)+" "+DT$+" "+RIGHT$(STR$(YEAR),2)
   GOTO 100
' Format "D" - use MM-DD
54 I=I+1:C$="-":GOTO 56
' Format "E" - use MM/DD
55 I=I+1:C$="/"
56 L=5:IF YEAR<0 THEN 98
   IF MONTH<1 OR MONTH>12 THEN 99
   DT$=RIGHT$(STR$(MONTH),2)+C$+RIGHT$(STR$(DAY+100),2)
   GOTO 100
' Format "F" - use Month Day, Year
58 I=I+1
   L=LEN(NOBLT$):IF YEAR<0 THEN 98
   L=LEN(NODATE$):IF MONTH<1 OR MONTH>12 THEN 99
   DT$=MO$(MONTH)+" "+RIGHT$(STR$(DAY),1-(DAY>9))+", "+RIGHT$(STR$(YEAR),4)
   GOTO 100
' Format "G" - use HH:MM:SS
60 I=I+1:L=8
   IF YEAR<0 THEN 96
   IF HOUR+MINUTE+SECOND=0 THEN 96
   DT$=RIGHT$(STR$(HOUR),2)+":"+RIGHT$(STR$(MINUTE+100),2)+":"+RIGHT$(STR$(SECOND+100),2)
   GOTO 100
' Format "H" - use HH:MM
61 I=I+1:L=5
   IF YEAR<0 THEN 96
   IF HOUR+MINUTE+SECOND=0 THEN 96
   DT$=RIGHT$(STR$(HOUR),2)+":"+RIGHT$(STR$(MINUTE+100),2)
   GOTO 100
' Format "I" - user HH:MMa
62 I=I+1:L=6
   IF YEAR<0 THEN 96
   IF HOUR+MINUTE+SECOND=0 THEN 96
   DT$=RIGHT$(STR$(((HOUR+11) MOD 12)+1),2)+":"+RIGHT$(STR$(MINUTE+100),2)+MID$("ap",1-(HOUR>11),1)
   GOTO 100
'
96 DT$=SPACE$(L):GOTO 100
98 DT$=LEFT$(NOBLT$+SPACE$(L),L):GOTO 100
99 DT$=LEFT$(NODATE$+SPACE$(L),L):GOTO 100
' Substitute DT$ into N$; then check rest of the line
100 N$=LEFT$(N$,M-1)+DT$+MID$(N$,I)
    J=M+LEN(DT$):GOTO 35
' Done with Line; write to output file
110 PRINT#3,N$
    GOTO 30
' End of Template - close template & output files
120 CLOSE #2,#3,#4
' Set Date,Time of output file to latest, then get next .CFG line
    CALL SETFDT(BLTOUT0$,YR0,MO0,DAY0,HR0,MN0,SEC0)
    GOTO 20
'
' End of .CFG file - close it and quit
'
125 PRINT:PRINT "End BLTDATER - ";DATE$:CLOSE:END
'
' Keep the latest date&time here
'
130 IF YR0<YEAR THEN 132 ELSE IF YR0>YEAR THEN 133
    IF MO0<MONTH THEN 132 ELSE IF MO0>MONTH THEN 133
    IF DAY0<DAY THEN 132 ELSE IF DAY0>DAY THEN 133
    IF HR0<HOUR THEN 132 ELSE IF HR0>HOUR THEN 133
    IF MN0<MINUTE THEN 132 ELSE IF MN0>MINUTE THEN 133
    IF SEC0>=SECOND THEN 133
132 YR0=YEAR:MO0=MONTH:DAY0=DAY:HR0=HOUR:MN0=MINUTE:SEC0=SECOND
133 RETURN
'
' Problems
'
135 PRINT "Bad Marker ('";MRK$;"')":GOTO 125
140 PRINT "No Data in .CFG File":GOTO 125
150 PRINT "Error "ERR;" occurred after Line"ERL:RESUME 125
