;  setfdt.asm  - Rod L Renner, FEMA/SL-AC, Sep 88
;
;  called from QB3.0
;
;  call setfdt(F$,yr%,mo%,day%,hour%,min%,sec%)
;                         opens ASCIIZ file F$
;                         if successful, sets the file's date and time
;                         values then closes the file.  No error codes
;                         returned.
;
code    segment byte public 'code'
        assume cs:code
        public setfdt
setfdt  proc far
        push bp
        mov bp,sp
        mov bx,[bp]+18
        mov dx,[bx]+2           ; get pointer to ASCIIZ string
        mov ax,3d42h
        int 21h                 ; open file (read/write, deny none)
        jc  done                ; quit now if unable to open
        push ax                 ; save file handle
        mov bx,[bp]+16
        xor dx,dx               ; clear dx
        add dx,[bx]             ; add get yr% (1980-2099, could be 0)
        jz month                ; skip ahead if yr%=0
        sub dx,1980
        mov cl,4
        shl dx,cl               ; shift year to make room for month
month:  mov bx,[bp]+14
        or dx,[bx]              ; combine year with month
        mov cl,5
        shl dx,cl               ; shift to make room for day
        mov bx,[bp]+12
        or dx,[bx]              ; put in day - dx = new date for file
;
        mov bx,[bp]+10
        mov ax,[bx]             ; get hours
        mov cl,6
        shl ax,cl               ; shift to make room for minutes
        mov bx,[bp]+8
        or ax,[bx]              ; combine hours with minutes
        mov cl,5
        shl ax,cl               ; shift to make room for 2-secs
        mov bx,[bp]+6
        mov cx,[bx]             ; get seconds
        shr cx,1                ; change to # 2-second increments
        or  cx,ax               ; combine to get cx = new time for file
;
        pop bx                  ; retrieve file handle
        mov ax,5701h
        int 21h                 ; set file's date and time
        mov ah,3eh
        int 21h                 ; close file
;
done:   pop bp
        ret 14                  ; all done
setfdt  endp
code    ends
        end
